Index: uspace/lib/bithenge/src/blob.c
===================================================================
--- uspace/lib/bithenge/src/blob.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/src/blob.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,5 +49,5 @@
  * @return EOK on success or an error code from errno.h.
  */
-errno_t bithenge_init_random_access_blob(bithenge_blob_t *blob,
+int bithenge_init_random_access_blob(bithenge_blob_t *blob,
     const bithenge_random_access_blob_ops_t *ops)
 {
@@ -67,5 +67,5 @@
 }
 
-static errno_t sequential_buffer(bithenge_sequential_blob_t *blob, aoff64_t end)
+static int sequential_buffer(bithenge_sequential_blob_t *blob, aoff64_t end)
 {
 	bool need_realloc = false;
@@ -81,5 +81,5 @@
 	}
 	aoff64_t size = end - blob->data_size;
-	errno_t rc = blob->ops->read(blob, blob->buffer + blob->data_size, &size);
+	int rc = blob->ops->read(blob, blob->buffer + blob->data_size, &size);
 	if (rc != EOK)
 		return rc;
@@ -100,8 +100,8 @@
 }
 
-static errno_t sequential_size(bithenge_blob_t *base, aoff64_t *size)
+static int sequential_size(bithenge_blob_t *base, aoff64_t *size)
 {
 	bithenge_sequential_blob_t *blob = blob_as_sequential(base);
-	errno_t rc;
+	int rc;
 	if (blob->ops->size) {
 		rc = blob->ops->size(blob, size);
@@ -121,5 +121,5 @@
 }
 
-static errno_t sequential_read(bithenge_blob_t *base, aoff64_t offset,
+static int sequential_read(bithenge_blob_t *base, aoff64_t offset,
     char *buffer, aoff64_t *size)
 {
@@ -127,5 +127,5 @@
 	aoff64_t end = offset + *size;
 	if (end > blob->data_size) {
-		errno_t rc = sequential_buffer(blob, end);
+		int rc = sequential_buffer(blob, end);
 		if (rc != EOK)
 			return rc;
@@ -158,5 +158,5 @@
  * @return EOK on success or an error code from errno.h.
  */
-errno_t bithenge_init_sequential_blob(bithenge_sequential_blob_t *blob,
+int bithenge_init_sequential_blob(bithenge_sequential_blob_t *blob,
     const bithenge_sequential_blob_ops_t *ops)
 {
@@ -167,5 +167,5 @@
 	// ops->size is optional
 
-	errno_t rc = bithenge_init_random_access_blob(sequential_as_blob(blob),
+	int rc = bithenge_init_random_access_blob(sequential_as_blob(blob),
 	    &sequential_ops);
 	if (rc != EOK)
@@ -195,5 +195,5 @@
 }
 
-static errno_t memory_size(bithenge_blob_t *base, aoff64_t *size)
+static int memory_size(bithenge_blob_t *base, aoff64_t *size)
 {
 	memory_blob_t *blob = blob_as_memory(base);
@@ -204,5 +204,5 @@
 }
 
-static errno_t memory_read(bithenge_blob_t *base, aoff64_t offset, char *buffer,
+static int memory_read(bithenge_blob_t *base, aoff64_t offset, char *buffer,
     aoff64_t *size)
 {
@@ -240,8 +240,8 @@
  * function fails or the blob is destroyed.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_new_blob_from_buffer(bithenge_node_t **out, const void *buffer,
+int bithenge_new_blob_from_buffer(bithenge_node_t **out, const void *buffer,
     size_t len, bool needs_free)
 {
-	errno_t rc;
+	int rc;
 	assert(buffer || !len);
 
@@ -278,5 +278,5 @@
  * @param len The length of the data.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_new_blob_from_data(bithenge_node_t **out, const void *data,
+int bithenge_new_blob_from_data(bithenge_node_t **out, const void *data,
     size_t len)
 {
@@ -309,5 +309,5 @@
 }
 
-static errno_t subblob_size(bithenge_blob_t *base, aoff64_t *size)
+static int subblob_size(bithenge_blob_t *base, aoff64_t *size)
 {
 	subblob_t *blob = blob_as_subblob(base);
@@ -316,5 +316,5 @@
 		return EOK;
 	} else {
-		errno_t rc = bithenge_blob_size(blob->source, size);
+		int rc = bithenge_blob_size(blob->source, size);
 		*size -= blob->offset;
 		return rc;
@@ -322,5 +322,5 @@
 }
 
-static errno_t subblob_read(bithenge_blob_t *base, aoff64_t offset,
+static int subblob_read(bithenge_blob_t *base, aoff64_t offset,
     char *buffer, aoff64_t *size)
 {
@@ -335,5 +335,5 @@
 }
 
-static errno_t subblob_read_bits(bithenge_blob_t *base, aoff64_t offset,
+static int subblob_read_bits(bithenge_blob_t *base, aoff64_t offset,
     char *buffer, aoff64_t *size, bool little_endian)
 {
@@ -368,10 +368,10 @@
 }
 
-static errno_t new_subblob(bithenge_node_t **out, bithenge_blob_t *source,
+static int new_subblob(bithenge_node_t **out, bithenge_blob_t *source,
     aoff64_t offset, aoff64_t size, bool size_matters)
 {
 	assert(out);
 	assert(source);
-	errno_t rc;
+	int rc;
 	subblob_t *blob = 0;
 
@@ -436,5 +436,5 @@
  * @param offset The offset within the input blob at which the new blob will start.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_new_offset_blob(bithenge_node_t **out, bithenge_blob_t *source,
+int bithenge_new_offset_blob(bithenge_node_t **out, bithenge_blob_t *source,
     aoff64_t offset)
 {
@@ -449,5 +449,5 @@
  * @param size The size of the new blob.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_new_subblob(bithenge_node_t **out, bithenge_blob_t *source,
+int bithenge_new_subblob(bithenge_node_t **out, bithenge_blob_t *source,
     aoff64_t offset, aoff64_t size)
 {
@@ -461,5 +461,5 @@
  * @return EOK on success, or an error code from errno.h.
  */
-errno_t bithenge_blob_equal(bool *out, bithenge_blob_t *a, bithenge_blob_t *b)
+int bithenge_blob_equal(bool *out, bithenge_blob_t *a, bithenge_blob_t *b)
 {
 	assert(a);
@@ -467,5 +467,5 @@
 	assert(b);
 	assert(b->base.blob_ops);
-	errno_t rc;
+	int rc;
 	char buffer_a[4096], buffer_b[4096];
 	aoff64_t offset = 0, size_a = sizeof(buffer_a), size_b = sizeof(buffer_b);
Index: uspace/lib/bithenge/src/common.h
===================================================================
--- uspace/lib/bithenge/src/common.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/src/common.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,5 @@
 #include "failure.h"
 #else
-static inline errno_t bithenge_should_fail(void)
+static inline int bithenge_should_fail(void)
 {
 	return 0;
Index: uspace/lib/bithenge/src/compound.c
===================================================================
--- uspace/lib/bithenge/src/compound.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/src/compound.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -62,8 +62,8 @@
 }
 
-static errno_t compose_apply(bithenge_transform_t *base, bithenge_scope_t *scope,
+static int compose_apply(bithenge_transform_t *base, bithenge_scope_t *scope,
     bithenge_node_t *in, bithenge_node_t **out)
 {
-	errno_t rc;
+	int rc;
 	compose_transform_t *self = transform_as_compose(base);
 	bithenge_node_inc_ref(in);
@@ -84,5 +84,5 @@
 }
 
-static errno_t compose_prefix_length(bithenge_transform_t *base,
+static int compose_prefix_length(bithenge_transform_t *base,
     bithenge_scope_t *scope, bithenge_blob_t *blob, aoff64_t *out)
 {
@@ -115,5 +115,5 @@
  * @param num The number of transforms.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_new_composed_transform(bithenge_transform_t **out,
+int bithenge_new_composed_transform(bithenge_transform_t **out,
     bithenge_transform_t **xforms, size_t num)
 {
@@ -126,5 +126,5 @@
 	}
 
-	errno_t rc;
+	int rc;
 	compose_transform_t *self = malloc(sizeof(*self));
 	if (!self) {
@@ -168,9 +168,9 @@
 }
 
-static errno_t if_transform_choose(if_transform_t *self, bithenge_scope_t *scope,
+static int if_transform_choose(if_transform_t *self, bithenge_scope_t *scope,
     bool *out)
 {
 	bithenge_node_t *cond_node;
-	errno_t rc = bithenge_expression_evaluate(self->expr, scope, &cond_node);
+	int rc = bithenge_expression_evaluate(self->expr, scope, &cond_node);
 	if (rc != EOK)
 		return rc;
@@ -184,10 +184,10 @@
 }
 
-static errno_t if_transform_apply(bithenge_transform_t *base,
+static int if_transform_apply(bithenge_transform_t *base,
     bithenge_scope_t *scope, bithenge_node_t *in, bithenge_node_t **out)
 {
 	if_transform_t *self = transform_as_if(base);
 	bool cond;
-	errno_t rc = if_transform_choose(self, scope, &cond);
+	int rc = if_transform_choose(self, scope, &cond);
 	if (rc != EOK)
 		return rc;
@@ -196,10 +196,10 @@
 }
 
-static errno_t if_transform_prefix_length(bithenge_transform_t *base,
+static int if_transform_prefix_length(bithenge_transform_t *base,
     bithenge_scope_t *scope, bithenge_blob_t *in, aoff64_t *out)
 {
 	if_transform_t *self = transform_as_if(base);
 	bool cond;
-	errno_t rc = if_transform_choose(self, scope, &cond);
+	int rc = if_transform_choose(self, scope, &cond);
 	if (rc != EOK)
 		return rc;
@@ -231,9 +231,9 @@
  * @param false_xform The transform to apply if the expression is false.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_if_transform(bithenge_transform_t **out,
+int bithenge_if_transform(bithenge_transform_t **out,
     bithenge_expression_t *expr, bithenge_transform_t *true_xform,
     bithenge_transform_t *false_xform)
 {
-	errno_t rc;
+	int rc;
 	if_transform_t *self = malloc(sizeof(*self));
 	if (!self) {
@@ -282,5 +282,5 @@
 }
 
-static errno_t partial_transform_apply(bithenge_transform_t *base,
+static int partial_transform_apply(bithenge_transform_t *base,
     bithenge_scope_t *scope, bithenge_node_t *in, bithenge_node_t **out)
 {
@@ -309,8 +309,8 @@
  * @param xform The subtransform to apply.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_partial_transform(bithenge_transform_t **out,
+int bithenge_partial_transform(bithenge_transform_t **out,
     bithenge_transform_t *xform)
 {
-	errno_t rc;
+	int rc;
 	partial_transform_t *self = malloc(sizeof(*self));
 	if (!self) {
Index: uspace/lib/bithenge/src/expression.c
===================================================================
--- uspace/lib/bithenge/src/expression.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/src/expression.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -48,5 +48,5 @@
  * @param[in] ops Operations provided by the expression.
  * @return EOK or an error code from errno.h. */
-errno_t bithenge_init_expression(bithenge_expression_t *self,
+int bithenge_init_expression(bithenge_expression_t *self,
     const bithenge_expression_ops_t *ops)
 {
@@ -88,8 +88,8 @@
 }
 
-static errno_t binary_expression_evaluate(bithenge_expression_t *base,
+static int binary_expression_evaluate(bithenge_expression_t *base,
     bithenge_scope_t *scope, bithenge_node_t **out)
 {
-	errno_t rc;
+	int rc;
 	binary_expression_t *self = expression_as_binary(base);
 	bithenge_node_t *a, *b;
@@ -250,9 +250,9 @@
  * @param b The second operand.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_binary_expression(bithenge_expression_t **out,
+int bithenge_binary_expression(bithenge_expression_t **out,
     bithenge_binary_op_t op, bithenge_expression_t *a,
     bithenge_expression_t *b)
 {
-	errno_t rc;
+	int rc;
 	binary_expression_t *self = malloc(sizeof(*self));
 	if (!self) {
@@ -283,5 +283,5 @@
 /***************** in_node_expression                        *****************/
 
-static errno_t in_node_evaluate(bithenge_expression_t *self,
+static int in_node_evaluate(bithenge_expression_t *self,
     bithenge_scope_t *scope, bithenge_node_t **out)
 {
@@ -306,5 +306,5 @@
  * @param[out] out Holds the new expression.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_in_node_expression(bithenge_expression_t **out)
+int bithenge_in_node_expression(bithenge_expression_t **out)
 {
 	if (bithenge_should_fail())
@@ -319,5 +319,5 @@
 /***************** current_node_expression                   *****************/
 
-static errno_t current_node_evaluate(bithenge_expression_t *self,
+static int current_node_evaluate(bithenge_expression_t *self,
     bithenge_scope_t *scope, bithenge_node_t **out)
 {
@@ -340,5 +340,5 @@
  * @param[out] out Holds the new expression.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_current_node_expression(bithenge_expression_t **out)
+int bithenge_current_node_expression(bithenge_expression_t **out)
 {
 	bithenge_expression_inc_ref(&current_node_expression);
@@ -368,5 +368,5 @@
 }
 
-static errno_t param_expression_evaluate(bithenge_expression_t *base,
+static int param_expression_evaluate(bithenge_expression_t *base,
     bithenge_scope_t *scope, bithenge_node_t **out)
 {
@@ -390,7 +390,7 @@
  * @param index The index of the parameter to get.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_param_expression(bithenge_expression_t **out, int index)
-{
-	errno_t rc;
+int bithenge_param_expression(bithenge_expression_t **out, int index)
+{
+	int rc;
 	param_expression_t *self = malloc(sizeof(*self));
 	if (!self)
@@ -430,5 +430,5 @@
 }
 
-static errno_t const_expression_evaluate(bithenge_expression_t *base,
+static int const_expression_evaluate(bithenge_expression_t *base,
     bithenge_scope_t *scope, bithenge_node_t **out)
 {
@@ -455,8 +455,8 @@
  * @param node The constant.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_const_expression(bithenge_expression_t **out,
+int bithenge_const_expression(bithenge_expression_t **out,
     bithenge_node_t *node)
 {
-	errno_t rc;
+	int rc;
 	const_expression_t *self = malloc(sizeof(*self));
 	if (!self) {
@@ -501,5 +501,5 @@
 }
 
-static errno_t scope_member_expression_evaluate(bithenge_expression_t *base, 
+static int scope_member_expression_evaluate(bithenge_expression_t *base, 
     bithenge_scope_t *scope, bithenge_node_t **out)
 {
@@ -511,5 +511,5 @@
 			continue;
 		bithenge_node_inc_ref(self->key);
-		errno_t rc = bithenge_node_get(cur, self->key, out);
+		int rc = bithenge_node_get(cur, self->key, out);
 		bithenge_node_dec_ref(cur);
 		if (rc != ENOENT) /* EOK or error */
@@ -537,8 +537,8 @@
  * @param key The key to search for in nodes being created.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_scope_member_expression(bithenge_expression_t **out,
+int bithenge_scope_member_expression(bithenge_expression_t **out,
     bithenge_node_t *key)
 {
-	errno_t rc;
+	int rc;
 	scope_member_expression_t *self = malloc(sizeof(*self));
 	if (!self) {
@@ -582,10 +582,10 @@
 }
 
-static errno_t subblob_expression_evaluate(bithenge_expression_t *base, 
+static int subblob_expression_evaluate(bithenge_expression_t *base, 
     bithenge_scope_t *scope, bithenge_node_t **out)
 {
 	subblob_expression_t *self = expression_as_subblob(base);
 	bithenge_node_t *start_node;
-	errno_t rc = bithenge_expression_evaluate(self->start, scope, &start_node);
+	int rc = bithenge_expression_evaluate(self->start, scope, &start_node);
 	if (rc != EOK)
 		return rc;
@@ -658,9 +658,9 @@
  * it is relative to the start.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_subblob_expression(bithenge_expression_t **out,
+int bithenge_subblob_expression(bithenge_expression_t **out,
     bithenge_expression_t *blob, bithenge_expression_t *start,
     bithenge_expression_t *limit, bool absolute_limit)
 {
-	errno_t rc;
+	int rc;
 	subblob_expression_t *self = malloc(sizeof(*self));
 	if (!self) {
@@ -709,8 +709,8 @@
 }
 
-static errno_t param_wrapper_fill_scope(param_wrapper_t *self, bithenge_scope_t
+static int param_wrapper_fill_scope(param_wrapper_t *self, bithenge_scope_t
     *inner, bithenge_scope_t *outer)
 {
-	errno_t rc;
+	int rc;
 	int num_params = bithenge_transform_num_params(self->transform);
 	rc = bithenge_scope_alloc_params(inner, num_params);
@@ -730,10 +730,10 @@
 }
 
-static errno_t param_wrapper_apply(bithenge_transform_t *base,
+static int param_wrapper_apply(bithenge_transform_t *base,
     bithenge_scope_t *outer, bithenge_node_t *in, bithenge_node_t **out)
 {
 	param_wrapper_t *self = transform_as_param_wrapper(base);
 	bithenge_scope_t *inner;
-	errno_t rc = bithenge_scope_new(&inner, outer);
+	int rc = bithenge_scope_new(&inner, outer);
 	if (rc != EOK)
 		return rc;
@@ -750,10 +750,10 @@
 }
 
-static errno_t param_wrapper_prefix_length(bithenge_transform_t *base,
+static int param_wrapper_prefix_length(bithenge_transform_t *base,
     bithenge_scope_t *outer, bithenge_blob_t *in, aoff64_t *out)
 {
 	param_wrapper_t *self = transform_as_param_wrapper(base);
 	bithenge_scope_t *inner;
-	errno_t rc = bithenge_scope_new(&inner, outer);
+	int rc = bithenge_scope_new(&inner, outer);
 	if (rc != EOK)
 		return rc;
@@ -770,5 +770,5 @@
 }
 
-static errno_t param_wrapper_prefix_apply(bithenge_transform_t *base,
+static int param_wrapper_prefix_apply(bithenge_transform_t *base,
     bithenge_scope_t *outer, bithenge_blob_t *in, bithenge_node_t **out_node,
     aoff64_t *out_length)
@@ -776,5 +776,5 @@
 	param_wrapper_t *self = transform_as_param_wrapper(base);
 	bithenge_scope_t *inner;
-	errno_t rc = bithenge_scope_new(&inner, outer);
+	int rc = bithenge_scope_new(&inner, outer);
 	if (rc != EOK)
 		return rc;
@@ -816,8 +816,8 @@
  * @param params The expressions used to calculate the parameters.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_param_wrapper(bithenge_transform_t **out,
+int bithenge_param_wrapper(bithenge_transform_t **out,
     bithenge_transform_t *transform, bithenge_expression_t **params)
 {
-	errno_t rc;
+	int rc;
 	int num_params = bithenge_transform_num_params(transform);
 	param_wrapper_t *self = malloc(sizeof(*self));
@@ -868,10 +868,10 @@
 }
 
-static errno_t expression_transform_apply(bithenge_transform_t *base,
+static int expression_transform_apply(bithenge_transform_t *base,
     bithenge_scope_t *scope, bithenge_node_t *in, bithenge_node_t **out)
 {
 	expression_transform_t *self = transform_as_expression(base);
 	bithenge_scope_t *inner;
-	errno_t rc = bithenge_scope_new(&inner, scope);
+	int rc = bithenge_scope_new(&inner, scope);
 	if (rc != EOK)
 		return rc;
@@ -900,8 +900,8 @@
  * @param expr The expression to evaluate.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_expression_transform(bithenge_transform_t ** out,
+int bithenge_expression_transform(bithenge_transform_t ** out,
     bithenge_expression_t *expr)
 {
-	errno_t rc;
+	int rc;
 	expression_transform_t *self = malloc(sizeof(*self));
 	if (!self) {
@@ -929,5 +929,5 @@
 /***************** inputless_transform            *****************/
 
-static errno_t inputless_transform_prefix_length(bithenge_transform_t *base,
+static int inputless_transform_prefix_length(bithenge_transform_t *base,
     bithenge_scope_t *scope, bithenge_blob_t *in, aoff64_t *out)
 {
@@ -936,5 +936,5 @@
 }
 
-static errno_t inputless_transform_prefix_apply(bithenge_transform_t *base,
+static int inputless_transform_prefix_apply(bithenge_transform_t *base,
     bithenge_scope_t *scope, bithenge_blob_t *in, bithenge_node_t **out_node,
     aoff64_t *out_size)
@@ -957,8 +957,8 @@
  * @param expr The expression to evaluate.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_inputless_transform(bithenge_transform_t ** out,
+int bithenge_inputless_transform(bithenge_transform_t ** out,
     bithenge_expression_t *expr)
 {
-	errno_t rc;
+	int rc;
 	expression_transform_t *self = malloc(sizeof(*self));
 	if (!self) {
@@ -1004,10 +1004,10 @@
 }
 
-static errno_t concat_blob_evaluate_b(concat_blob_t *self)
+static int concat_blob_evaluate_b(concat_blob_t *self)
 {
 	if (self->b)
 		return EOK;
 	bithenge_node_t *b_node;
-	errno_t rc = bithenge_expression_evaluate(self->b_expr, self->scope,
+	int rc = bithenge_expression_evaluate(self->b_expr, self->scope,
 	    &b_node);
 	if (rc != EOK)
@@ -1026,8 +1026,8 @@
 }
 
-static errno_t concat_blob_size(bithenge_blob_t *base, aoff64_t *size)
+static int concat_blob_size(bithenge_blob_t *base, aoff64_t *size)
 {
 	concat_blob_t *self = blob_as_concat(base);
-	errno_t rc = concat_blob_evaluate_b(self);
+	int rc = concat_blob_evaluate_b(self);
 	if (rc != EOK)
 		return rc;
@@ -1037,8 +1037,8 @@
 }
 
-static errno_t concat_blob_read(bithenge_blob_t *base, aoff64_t offset,
+static int concat_blob_read(bithenge_blob_t *base, aoff64_t offset,
     char *buffer, aoff64_t *size)
 {
-	errno_t rc;
+	int rc;
 	concat_blob_t *self = blob_as_concat(base);
 
@@ -1065,8 +1065,8 @@
 }
 
-static errno_t concat_blob_read_bits(bithenge_blob_t *base, aoff64_t offset,
+static int concat_blob_read_bits(bithenge_blob_t *base, aoff64_t offset,
     char *buffer, aoff64_t *size, bool little_endian)
 {
-	errno_t rc;
+	int rc;
 	concat_blob_t *self = blob_as_concat(base);
 
@@ -1118,5 +1118,5 @@
  * @param b The second blob.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_concat_blob(bithenge_node_t **out, bithenge_blob_t *a,
+int bithenge_concat_blob(bithenge_node_t **out, bithenge_blob_t *a,
     bithenge_blob_t *b)
 {
@@ -1124,5 +1124,5 @@
 	assert(a);
 	assert(b);
-	errno_t rc;
+	int rc;
 	concat_blob_t *self = malloc(sizeof(*self));
 	if (!self) {
@@ -1160,5 +1160,5 @@
  * @param scope The scope in which @a b_expr should be evaluated.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_concat_blob_lazy(bithenge_node_t **out, bithenge_blob_t *a,
+int bithenge_concat_blob_lazy(bithenge_node_t **out, bithenge_blob_t *a,
     bithenge_expression_t *b_expr, bithenge_scope_t *scope)
 {
@@ -1167,5 +1167,5 @@
 	assert(b_expr);
 	assert(scope);
-	errno_t rc;
+	int rc;
 	concat_blob_t *self = malloc(sizeof(*self));
 	if (!self) {
Index: uspace/lib/bithenge/src/failure.c
===================================================================
--- uspace/lib/bithenge/src/failure.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/src/failure.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -85,5 +85,5 @@
 {
 	g_initialized = 1;
-	errno_t rc = atexit(atexit_handler);
+	int rc = atexit(atexit_handler);
 	if (rc)
 		exit(127);
@@ -96,5 +96,5 @@
 /* Record a hit for a backtrace address and return whether this is the first
  * hit. */
-static inline errno_t backtrace_item_hit(void *addr)
+static inline int backtrace_item_hit(void *addr)
 {
 	backtrace_item_t **bip;
@@ -120,5 +120,5 @@
 }
 
-errno_t bithenge_should_fail(void)
+int bithenge_should_fail(void)
 {
 	g_failure_index++;
@@ -202,5 +202,5 @@
 }
 
-errno_t bithenge_failure_ferror(FILE *stream)
+int bithenge_failure_ferror(FILE *stream)
 {
 	if (bithenge_should_fail())
@@ -216,5 +216,5 @@
 }
 
-errno_t bithenge_failure_open(const char *pathname, int flags)
+int bithenge_failure_open(const char *pathname, int flags)
 {
 	if (bithenge_should_fail()) {
@@ -225,5 +225,5 @@
 }
 
-errno_t bithenge_failure_fstat(int fd, vfs_stat_t *buf)
+int bithenge_failure_fstat(int fd, struct stat *buf)
 {
 	if (bithenge_should_fail()) {
Index: uspace/lib/bithenge/src/failure.h
===================================================================
--- uspace/lib/bithenge/src/failure.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/src/failure.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -44,13 +44,13 @@
 #include <stddef.h>
 
-errno_t bithenge_should_fail(void);
+int bithenge_should_fail(void);
 void *bithenge_failure_malloc(size_t);
 void *bithenge_failure_realloc(void *, size_t);
 ssize_t bithenge_failure_read(int, void *, size_t);
 off_t bithenge_failure_lseek(int, off_t, int);
-errno_t bithenge_failure_ferror(FILE *);
+int bithenge_failure_ferror(FILE *);
 char *bithenge_failure_str_ndup(const char *, size_t);
-errno_t bithenge_failure_open(const char *, int);
-errno_t bithenge_failure_fstat(int, vfs_stat_t *);
+int bithenge_failure_open(const char *, int);
+int bithenge_failure_fstat(int, struct stat *);
 
 #ifndef BITHENGE_FAILURE_DECLS_ONLY
Index: uspace/lib/bithenge/src/file.c
===================================================================
--- uspace/lib/bithenge/src/file.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/src/file.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -63,5 +63,5 @@
 }
 
-static errno_t file_size(bithenge_blob_t *base, aoff64_t *size)
+static int file_size(bithenge_blob_t *base, aoff64_t *size)
 {
 	file_blob_t *blob = blob_as_file(base);
@@ -70,5 +70,5 @@
 }
 
-static errno_t file_read(bithenge_blob_t *base, aoff64_t offset, char *buffer,
+static int file_read(bithenge_blob_t *base, aoff64_t offset, char *buffer,
     aoff64_t *size)
 {
@@ -78,5 +78,5 @@
 
 	size_t amount_read;
-	errno_t rc = vfs_read(blob->fd, &offset, buffer, *size, &amount_read);
+	int rc = vfs_read(blob->fd, &offset, buffer, *size, &amount_read);
 	if (rc != EOK)
 		return errno;
@@ -98,10 +98,10 @@
 };
 
-static errno_t new_file_blob(bithenge_node_t **out, int fd, bool needs_close)
+static int new_file_blob(bithenge_node_t **out, int fd, bool needs_close)
 {
 	assert(out);
 
-	vfs_stat_t stat;
-	errno_t rc = vfs_stat(fd, &stat);
+	struct stat stat;
+	int rc = vfs_stat(fd, &stat);
 	if (rc != EOK) {
 		if (needs_close)
@@ -141,12 +141,11 @@
  * @param filename The name of the file.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_new_file_blob(bithenge_node_t **out, const char *filename)
+int bithenge_new_file_blob(bithenge_node_t **out, const char *filename)
 {
 	assert(filename);
 
-	int fd;
-	errno_t rc = vfs_lookup_open(filename, WALK_REGULAR, MODE_READ, &fd);
-	if (rc != EOK)
-		return rc;
+	int fd = vfs_lookup_open(filename, WALK_REGULAR, MODE_READ);
+	if (fd < 0)
+		return errno;
 
 	return new_file_blob(out, fd, true);
@@ -158,5 +157,5 @@
  * @param fd The file descriptor.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_new_file_blob_from_fd(bithenge_node_t **out, int fd)
+int bithenge_new_file_blob_from_fd(bithenge_node_t **out, int fd)
 {
 	return new_file_blob(out, fd, false);
@@ -168,5 +167,5 @@
  * @param file The file pointer.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_new_file_blob_from_file(bithenge_node_t **out, FILE *file)
+int bithenge_new_file_blob_from_file(bithenge_node_t **out, FILE *file)
 {
 	int fd = fileno(file);
Index: uspace/lib/bithenge/src/helenos/block.c
===================================================================
--- uspace/lib/bithenge/src/helenos/block.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/src/helenos/block.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -61,5 +61,5 @@
 }
 
-static errno_t block_size(bithenge_blob_t *base, aoff64_t *size)
+static int block_size(bithenge_blob_t *base, aoff64_t *size)
 {
 	block_blob_t *self = blob_as_block(base);
@@ -68,5 +68,5 @@
 }
 
-static errno_t block_read(bithenge_blob_t *base, aoff64_t offset, char *buffer,
+static int block_read(bithenge_blob_t *base, aoff64_t offset, char *buffer,
     aoff64_t *size)
 {
@@ -96,10 +96,10 @@
  * @param service_id The service ID of the block device.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_new_block_blob(bithenge_node_t **out, service_id_t service_id)
+int bithenge_new_block_blob(bithenge_node_t **out, service_id_t service_id)
 {
 	assert(out);
 
 	// Initialize libblock
-	errno_t rc;
+	int rc;
 	rc = block_init(service_id, 2048);
 	if (rc != EOK)
Index: uspace/lib/bithenge/src/helenos/block.h
===================================================================
--- uspace/lib/bithenge/src/helenos/block.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/src/helenos/block.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,5 @@
 #include <bithenge/tree.h>
 
-errno_t bithenge_new_block_blob(bithenge_node_t **, service_id_t);
+int bithenge_new_block_blob(bithenge_node_t **, service_id_t);
 
 #endif
Index: uspace/lib/bithenge/src/helenos/common.h
===================================================================
--- uspace/lib/bithenge/src/helenos/common.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/src/helenos/common.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -64,5 +64,5 @@
 }
 
-static inline errno_t string_iterator_next(string_iterator_t *i, wchar_t *out)
+static inline int string_iterator_next(string_iterator_t *i, wchar_t *out)
 {
 	*out = i->ch;
@@ -81,9 +81,9 @@
 }
 
-static inline errno_t bithenge_parse_int(const char *start, bithenge_int_t *result)
+static inline int bithenge_parse_int(const char *start, bithenge_int_t *result)
 {
 	const char *real_start = *start == '-' ? start + 1 : start;
 	uint64_t val;
-	errno_t rc = str_uint64_t(real_start, NULL, 10, false, &val);
+	int rc = str_uint64_t(real_start, NULL, 10, false, &val);
 	*result = val;
 	if (*start == '-')
Index: uspace/lib/bithenge/src/linux/common.h
===================================================================
--- uspace/lib/bithenge/src/linux/common.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/src/linux/common.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -55,5 +55,5 @@
 }
 
-static inline errno_t string_iterator_next(string_iterator_t *i, wchar_t *out)
+static inline int string_iterator_next(string_iterator_t *i, wchar_t *out)
 {
 	wint_t rc = btowc(*(*i)++); // TODO
@@ -82,5 +82,5 @@
 }
 
-static inline errno_t str_lcmp(const char *s1, const char *s2, size_t max_len)
+static inline int str_lcmp(const char *s1, const char *s2, size_t max_len)
 {
 	return strncmp(s1, s2, max_len);
@@ -132,5 +132,5 @@
 }
 
-static inline errno_t bithenge_parse_int(const char *start, bithenge_int_t *result)
+static inline int bithenge_parse_int(const char *start, bithenge_int_t *result)
 {
 	errno = 0;
